;;; **********************************************************
;;; **********              registry          ****************
;;; **********************************************************
  
;;; needs Suregen, Dictionary, GermanDict

;;;(EVAL-WHEN (:compile-toplevel :load-toplevel :execute)

(EVAL-WHEN (:execute :load-toplevel)
   
  (in-package :common-graphics-user)
  
  (DECLAIM (SPECIAL CurrentScheme TP_CA Ex_main *patient* Doc_main *PX_Registry* *itemlist-NONE* s-hals))
  
  (SETF CurrentScheme (MAKE-INSTANCE 'ATBOX))
   
  (Instantiate CurrentScheme)
  
  (Clear-Registry GUI-Registry)
  
  (Register i-jetzigeBeschwerden GUI-Registry 'GuiItems)
  
  (Add-To-Registry GUI-Registry :KA_BeruflicherStatus_KA (OccupationalStatus *patient*) :state :bool NIL)
  (Add-To-Registry GUI-Registry :KA_BeruflicherStatus_arbeitet (OccupationalStatus *patient*) :state :bool :active)
  (Add-To-Registry GUI-Registry :KA_BeruflicherStatus_berentet (OccupationalStatus *patient*) :state :bool :terminated)
  (Add-To-Registry GUI-Registry :KA_BeruflicherStatus_arbeitsunfaehig (OccupationalStatus *patient*) :state :bool :paused)
  (Add-To-Registry GUI-Registry :KA_SA_SEIT (OccupationalStatus *patient*) :since :val)
  (Add-To-Registry GUI-Registry :KA_SA_AU_BER_SEIT (OccupationalStatus *patient*) :StateSince :val)
  (Add-To-Registry GUI-Registry :KA_SA_ALS (OccupationalStatus *patient*) :occupation :val)  
  (Add-To-Registry GUI-Registry :KA_ACT_COMP i-jetzigeBeschwerden :beschwerden :val)
  (Add-To-Registry GUI-Registry :KA_ACT_COMP_none i-jetzigeBeschwerden :beschwerden :bool :none '(wid-val
                                                                                                  (Reset-Widget :KA_ACT_COMP T)))
  
  (Add-To-Registry GUI-Registry :AP_LOC_PRECORDIAL (Location i-thoraxschmerz) 'loclist :valMulti i-praekordial)
  (Add-To-Registry GUI-Registry :AP_LOC_leftthorax (Location i-thoraxschmerz) 'loclist :valMulti i-linksthorakal)
  (Add-To-Registry GUI-Registry :AP_LOC_retrosternal (Location i-thoraxschmerz) 'loclist :valMulti i-retrosternal)
  
  (Add-To-Registry GUI-Registry :AP_RAD_neck (Radiation i-thoraxschmerz) 'loclist :valMulti s-Hals)
  (Add-To-Registry GUI-Registry :AP_RAD_LEFTARM (Radiation i-thoraxschmerz) 'loclist :valMulti s-arm-li)
  (Add-To-Registry GUI-Registry :AP_RAD_SHOULDER (Radiation i-thoraxschmerz) 'loclist :valMulti s-Schulter)
  (Add-To-Registry GUI-Registry :AP_RAD_JAW (Radiation i-thoraxschmerz) 'loclist :valMulti s-Kiefer)
  
  (Add-To-Registry GUI-Registry :AP_TRIG_PS_STRESS (Triggers i-thoraxschmerz) 'itemlist :valMulti s-emotionalStress)
  (Add-To-Registry GUI-Registry :AP_TRIG_BO_STRESS (Triggers i-thoraxschmerz) 'itemlist :valMulti s-physicalExercise)
  (Add-To-Registry GUI-Registry :AP_TRIG_POSTPRANDIAL (Triggers i-thoraxschmerz) 'itemlist :valMulti s-postprandial)
  (Add-To-Registry GUI-Registry :AP_TRIG_ATREST (Triggers i-thoraxschmerz) 'itemlist :valMulti s-atRest)
  (Add-To-Registry GUI-Registry :AP_TRIG_NIGHT (Triggers i-thoraxschmerz) 'itemlist :valMulti s-atnight)
  (Add-To-Registry GUI-Registry :AP_TRIG_COLD (Triggers i-thoraxschmerz) 'itemlist :valMulti s-cold)
  (Add-To-Registry GUI-Registry :AP_TRIG_WEATH (Triggers i-thoraxschmerz) 'itemlist :valMulti s-chgWeather)
  
  (Add-To-Registry GUI-Registry :AP_QUAL_POINTED (Quality i-thoraxschmerz) 'itemlist :valMulti s-pointed '(wid-val
                                                                                                           (Reset-Widget :AP_QUAL_BELTLIKE)))
  (Add-To-Registry GUI-Registry :AP_QUAL_BELTLIKE (Quality i-thoraxschmerz) 'itemlist :valMulti s-beltlike '(wid-val
                                                                                                             (Reset-Widget :AP_QUAL_POINTED)))
  
  (Add-To-Registry GUI-Registry :AP_QUAL_BURNING (Quality i-thoraxschmerz) 'itemlist :valMulti s-burning)
  (Add-To-Registry GUI-Registry :AP_QUAL_SHARP (Quality i-thoraxschmerz) 'itemlist :valMulti s-sharp)
  (Add-To-Registry GUI-Registry :AP_QUAL_ZIEHEND (Quality i-thoraxschmerz) 'itemlist :valMulti s-ziehend)
  (Add-To-Registry GUI-Registry :AP_QUAL_CRAMPLIKE (Quality i-thoraxschmerz) 'itemlist :valMulti s-cramplike)
  
  (Add-To-Registry GUI-Registry :KA_CCS_KA i-thoraxschmerz :nyha :bool 0)
  (Add-To-Registry GUI-Registry :KA_CCS_none i-thoraxschmerz :nyha :bool 1)
  (Add-To-Registry GUI-Registry :KA_CCS_I i-thoraxschmerz :nyha :bool 2)
  (Add-To-Registry GUI-Registry :KA_CCS_II i-thoraxschmerz :nyha :bool 3)
  (Add-To-Registry GUI-Registry :KA_CCS_III i-thoraxschmerz :nyha :bool 4)
  (Add-To-Registry GUI-Registry :KA_CCS_IV i-thoraxschmerz :nyha :bool 5)
  
  (Add-To-Registry GUI-Registry :AP_NITROHELPS_NO i-thoraxschmerz :Nitrosensitive :table '((T 1) (NIL 0))
                   '(wid-val (Reset-Widget :AP_NITROHELPS)))
  (Add-To-Registry GUI-Registry :AP_NITROHELPS i-thoraxschmerz :Nitrosensitive :table '((T 2) (NIL 0))
                   '(wid-val (Reset-Widget :AP_NITROHELPS_NO)))
  (Add-To-Registry GUI-Registry :AP_NITROHELPSAFTER i-thoraxschmerz :Nitrohelpsafter :val)
  
  
  (Add-To-Registry GUI-Registry :RH_KA (symptomList i-rhythm_complaint) 'itemlist :boolintern NIL
                   '(wid-val (MAPC 'Reset-Widget '(:RH_PALP :RH_STOLP :RH_NONE))))
  (Add-To-Registry GUI-Registry :RH_none (symptomList i-rhythm_complaint) 'itemlist :boolintern (LIST s-none)
                   '(wid-val (MAPC 'Reset-Widget '(:RH_PALP :RH_STOLP :RH_KA))))
  (Add-To-Registry GUI-Registry :RH_PALP (symptomList i-rhythm_complaint) 'itemlist :valMulti s-palpitation
                   '(wid-val (MAPC 'Reset-Widget '(:RH_KA :RH_NONE))))
  (Add-To-Registry GUI-Registry :RH_STOLP (symptomList i-rhythm_complaint) 'itemlist :valMulti s-cardiac_irregularity
                   '(wid-val (MAPC 'Reset-Widget '(:RH_KA :RH_NONE))))
  
  (Add-To-Registry GUI-Registry :KA_NYHA_KA i-dyspnea :grade :bool 0)
  (Add-To-Registry GUI-Registry :KA_NYHA_none i-dyspnea :grade :bool 1)
  (Add-To-Registry GUI-Registry :KA_NYHA_I i-dyspnea :grade :bool 2)
  (Add-To-Registry GUI-Registry :KA_NYHA_II i-dyspnea :grade :bool 3)
  (Add-To-Registry GUI-Registry :KA_NYHA_III i-dyspnea :grade :bool 4)
  (Add-To-Registry GUI-Registry :KA_NYHA_IV i-dyspnea :grade :bool 5)
  (Add-To-Registry GUI-Registry :DYSP_ETAGEN i-dyspnea :floors :val)
  (Add-To-Registry GUI-Registry :DYSP_NOCT i-dyspnea :atnight :val)
  
  (Add-To-Registry GUI-Registry :KA_EDEMA_WHEN_KA i-cardiacedema :grade :bool 0)
  (Add-To-Registry GUI-Registry :KA_EDEMA_WHEN_NONE i-cardiacedema :grade :bool 1)
  (Add-To-Registry GUI-Registry :KA_EDEMA_WHEN_SOMETIMES i-cardiacedema :grade :bool 2)
  (Add-To-Registry GUI-Registry :KA_EDEMA_WHEN_OFTEN i-cardiacedema :grade :bool 3)
  (Add-To-Registry GUI-Registry :KA_EDEMA_WHEN_PERMANENT i-cardiacedema :grade :bool 4)
  
  (Add-To-Registry GUI-Registry :EDEMA_ANKLE (location i-cardiacedema) 'itemlist :valMulti l-ankle
                   '(wid-val (MAPC 'Reset-Widget '(:EDEMA_GENERAL))))
  (Add-To-Registry GUI-Registry :EDEMA_EYELID (location i-cardiacedema) 'itemlist :valMulti l-eyelid
                   '(wid-val (MAPC 'Reset-Widget '(:EDEMA_GENERAL))))
  (Add-To-Registry GUI-Registry :EDEMA_SACRAL (location i-cardiacedema) 'itemlist :valMulti l-os_sacrum
                   '(wid-val (MAPC 'Reset-Widget '(:EDEMA_GENERAL))))
  (Add-To-Registry GUI-Registry :EDEMA_PRETIB (location i-cardiacedema) 'itemlist :valMulti l-pretibial
                   '(wid-val (MAPC 'Reset-Widget '(:EDEMA_GENERAL))))
  (Add-To-Registry GUI-Registry :EDEMA_GENERAL (location i-cardiacedema) 'itemlist :valMulti l-generalized
                   '(wid-val (MAPC 'Reset-Widget '(:EDEMA_PRETIB :EDEMA_SACRAL :EDEMA_EYELID :EDEMA_ANKLE))))
  
  (Add-To-Registry GUI-Registry :EDEMA_LAT_KA i-cardiacedema :laterality :bool 0)
  (Add-To-Registry GUI-Registry :EDEMA_LAT_LE i-cardiacedema :laterality :bool 1)
  (Add-To-Registry GUI-Registry :EDEMA_LAT_RI i-cardiacedema :laterality :bool 2)
  (Add-To-Registry GUI-Registry :EDEMA_LAT_BOTH i-cardiacedema :laterality :bool 3)
  
  (Add-To-Registry GUI-Registry :KA_NYKTURIA_KA i-nycturia :grade :bool 0)
  (Add-To-Registry GUI-Registry :KA_NYKTURIA_NONE i-nycturia :grade :bool 1)
  (Add-To-Registry GUI-Registry :KA_NYKTURIA_SELDOM i-nycturia :grade :bool 2)
  (Add-To-Registry GUI-Registry :KA_NYKTURIA_1 i-nycturia :grade :bool 3)
  (Add-To-Registry GUI-Registry :KA_NYKTURIA_2 i-nycturia :grade :bool 4)
  (Add-To-Registry GUI-Registry :KA_NYKTURIA_3 i-nycturia :grade :bool 5)
  
 
  
  ;;; ******************************************************************************************
  ;;; ************************************  Phoenix-Registry  **********************************
  ;;; ******************************************************************************************
  
  (SETF *px-Registry* NIL)
  
  (Add-To-External-Registry '*px-Registry* 
                            '(occupation (SET-OW-SLOTVAL (OccupationalStatus *patient*) :occupation it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(occ_status (SET-OW-SLOTVAL (OccupationalStatus *patient*)
                                                         :state (ASSOC-val it '((1 :active) (2 :paused)
                                                                                (3 :terminated))))))
  (Add-To-External-Registry '*px-Registry* 
                            '(occ_since (SET-OW-SLOTVAL (OccupationalStatus *patient*) :since it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(occ_status_since (SET-OW-SLOTVAL (OccupationalStatus *patient*) :statesince it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(pres_compl (SET-OW-SLOTVAL i-jetzigeBeschwerden :beschwerden it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(pres_compl_none (SET-OW-SLOTVAL i-jetzigeBeschwerden :beschwerden (WHEN (EQUAL it 1) :none))))
  
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_LOK_CORD (locationpresent (Location i-thoraxschmerz) i-praekordial it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_LOK_LEFTTH (locationpresent (Location i-thoraxschmerz) i-linksthorakal it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_LOK_RETROST (locationpresent (Location i-thoraxschmerz) i-retrosternal it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_TRIG_REST (itempresent (Triggers i-thoraxschmerz) s-atRest it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_TRIG_P_EX (itempresent (Triggers i-thoraxschmerz) s-physicalExercise it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_TRIG_M_EX (itempresent (Triggers i-thoraxschmerz) s-emotionalStress it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_TRIG_COLD (itempresent (Triggers i-thoraxschmerz) s-cold it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_TRIG_NOCT (itempresent (Triggers i-thoraxschmerz) s-atnight it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_TRIG_POSTP (itempresent (Triggers i-thoraxschmerz) s-postprandial it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_TRIG_WEATH (itempresent (Triggers i-thoraxschmerz) s-chgWeather it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_RAD_HALS (locationpresent (Radiation i-thoraxschmerz) s-Hals it))) 
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_RAD_LEFT_ARM (locationpresent (Radiation i-thoraxschmerz) s-arm-li it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_RAD_SHOULDER (locationpresent (Radiation i-thoraxschmerz) s-schulter it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_RAD_KIEFER (locationpresent (Radiation i-thoraxschmerz) s-kiefer it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_QUAL_BRENNEND (itempresent (Quality i-thoraxschmerz) s-burning it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_QUAL_STECHEND (itempresent (Quality i-thoraxschmerz) s-sharp it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_QUAL_ZIEHEND (itempresent (Quality i-thoraxschmerz) s-ziehend it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_QUAL_KRAMPF (itempresent (Quality i-thoraxschmerz) s-cramplike it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_QUAL_PUNKTF (itempresent (Quality i-thoraxschmerz) s-pointed it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_QUAL_GUERTELF (itempresent (Quality i-thoraxschmerz) s-beltlike it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_NYHA (SET-OW-SLOTVAL i-thoraxschmerz :NYHA it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_NITRO (SET-OW-SLOTVAL i-thoraxschmerz :Nitrosensitive it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(AP_NITRO_HELPSAFTER (SET-OW-SLOTVAL i-thoraxschmerz :Nitrohelpsafter it)))
  
  
  (Add-To-External-Registry '*px-Registry* 
                            '(RH_DIS_KA (WHEN it (SETF (SLOT-VALUE (symptomList i-rhythm_complaint) 'itemlist) NIL))))
  (Add-To-External-Registry '*px-Registry* 
                            '(RH_DIS_NO (WHEN it (SETF (SLOT-VALUE (symptomList i-rhythm_complaint) 'itemlist) *itemlist-NONE*))))
  (Add-To-External-Registry '*px-Registry* 
                            '(RH_DIS_PALP (itempresent (symptomList i-rhythm_complaint) s-palpitation it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(RH_DIS_STOLP (itempresent (symptomList i-rhythm_complaint) s-cardiac_irregularity it)))
    
  
  (Add-To-External-Registry '*px-Registry* 
                            '(DYSPNOE_GRAD (SET-OW-SLOTVAL i-dyspnea :grade it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(DYSPNOE_NOCT (SET-OW-SLOTVAL i-dyspnea :atNight (make-bool it))))
  (Add-To-External-Registry '*px-Registry* 
                            '(DYSPNOE_stair_fl (SET-OW-SLOTVAL i-dyspnea :floors it)))
   
  
  (Add-To-External-Registry '*px-Registry* 
                            '(EDEMA_WHEN (SET-OW-SLOTVAL i-cardiacedema :grade it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(EDEMA_ANKLE (itempresent (location i-cardiacedema) l-ankle it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(EDEMA_eyelid (itempresent (location i-cardiacedema) l-eyelid it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(EDEMA_sacral (itempresent (location i-cardiacedema) l-os_sacrum it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(EDEMA_pretib (itempresent (location i-cardiacedema) l-pretibial it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(EDEMA_general (itempresent (location i-cardiacedema) l-generalized it)))
  (Add-To-External-Registry '*px-Registry* 
                            '(EDEMA_LAT (SET-OW-SLOTVAL i-cardiacedema :laterality it)))
  
  (Add-To-External-Registry '*px-Registry* 
                            '(NYCTURIA (SET-OW-SLOTVAL i-nycturia :grade it)))  
  
  ) ;;;EVAL-WHEN